/*
 * BikeRoutesListWindow.java
 *
 * Created on 5  2004 ., 12:50
 */

package com.fn.BikersLog;


import java.awt.Frame;


/**
 *
 * @author  asso
 */
public class AquaRoutesListWindow extends GeneralListWindow {
    
    private Log log;
    
    /** Creates a new instance of BikeRoutesListWindow */
    public AquaRoutesListWindow(Frame owner, Log log) {
        super(owner, I18n.getMsg("aquaRoutesListForm.title"));
        this.log = log;
        itemsList.setModel(log.getAquaRoutesList());
    }
    
    public static void execute(Frame owner, Log log) {
        AquaRoutesListWindow arw = new AquaRoutesListWindow(owner, log);
        arw.setVisible(true);
    }
    
    /** This method is called when delete confirmation window needs message */
    protected String getDelPrompt(javax.swing.ListModel model, int itemNo) {
        return I18n.getMsg("aquaRoutesListForm.areYouSure");
    }
    
    /** This method is called when add button pressed */
    protected void onAdd(javax.swing.ListModel model) {
        AquaRoute route = AquaRouteWindow.add(this, log.getImageStorage());
        if (null != route) {
            log.getAquaRoutesList().add(route);
            itemsList.setSelectedIndex(log.getAquaRoutesList().getSize() - 1);
            log.markAsUnsaved();
        }
    }
    
    /** This method is called when edit button pressed */
    protected void onEdit(javax.swing.ListModel model, int itemNo) {
        AquaRoute route = log.getAquaRoutesList().get(itemNo);
        if (AquaRouteWindow.edit(this, route)) {
            log.getAquaRoutesList().change(itemNo);
            log.markAsUnsaved();
        }
    }
    
    /** This method is called when delete button pressed */
    protected void onDelete(javax.swing.ListModel model, int itemNo) {
        log.getAquaRoutesList().delete(itemNo);
        log.markAsUnsaved();
    }
    
}
