/*
 * BikeWindow.java
 *
 * Created on 12  2003 ., 14:07
 */

package com.fn.BikersLog;


import javax.swing.DefaultComboBoxModel;
import javax.swing.JOptionPane;


/**
 *
 * @author  asso
 */
public class BikeWindow extends javax.swing.JDialog {

    private Bike bike;
    private boolean okPressed = false;
    
    /** Creates new form BikeWindow */
    public BikeWindow(java.awt.Dialog parent, Bike bike, boolean edit) {
        super(parent, true);
        this.bike = bike;
        initComponents();
        
        if (edit)
            setTitle(I18n.getMsg("bikeForm.editTitle"));
        else
            setTitle(I18n.getMsg("bikeForm.newTitle"));
        
        nameTextField.setText(bike.getName());
        descrTextArea.setText(bike.getDescription());
     
        String items[] = new String[10];
        for (int i = 0; i < items.length; i++)
            items[i] = I18n.getMsg("bikeType." + Integer.toString(i + 1));
        DefaultComboBoxModel comboBoxModel = new DefaultComboBoxModel(items);
        typeComboBox.setModel(comboBoxModel);
        typeComboBox.setSelectedIndex(bike.getType() - 1);
        weightTextField.setText(Utils.doubleToStr(Units.fromStdWeight(bike.getWeight())));
        
        Utils.centerWindow(this, parent);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel2 = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel3 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        nameTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        typeComboBox = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        weightTextField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        descrTextArea = new javax.swing.JTextArea();
        jLabel5 = new javax.swing.JLabel();
        imageEditor = new ImageEditor(bike.getImage(), bike.getImageStorage());

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 8, 8));

        okButton.setText(I18n.getMsg("generic.ok"));
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        jPanel2.add(okButton);

        cancelButton.setText(I18n.getMsg("generic.cancel"));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jPanel2.add(cancelButton);

        getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 0, 8)));
        jPanel3.setLayout(new java.awt.GridBagLayout());

        jPanel3.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel1.setText(I18n.getMsg("bikeForm.name"));
        jLabel1.setMaximumSize(new java.awt.Dimension(330, 16));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 4);
        jPanel3.add(jLabel1, gridBagConstraints);

        nameTextField.setPreferredSize(new java.awt.Dimension(180, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 4, 4, 0);
        jPanel3.add(nameTextField, gridBagConstraints);

        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel3.setText(I18n.getMsg("bikeForm.type"));
        jLabel3.setMaximumSize(new java.awt.Dimension(510, 16));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 4, 4);
        jPanel3.add(jLabel3, gridBagConstraints);

        typeComboBox.setMaximumRowCount(10);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 0);
        jPanel3.add(typeComboBox, gridBagConstraints);

        jLabel4.setText(I18n.getMsg("bikeForm.weight"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 4, 4);
        jPanel3.add(jLabel4, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 0);
        jPanel3.add(weightTextField, gridBagConstraints);

        jLabel2.setText(I18n.getMsg("bikeForm.descr"));
        jLabel2.setAlignmentY(0.0F);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 0, 4);
        jPanel3.add(jLabel2, gridBagConstraints);

        jScrollPane1.setPreferredSize(new java.awt.Dimension(280, 100));
        descrTextArea.setLineWrap(true);
        jScrollPane1.setViewportView(descrTextArea);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 0);
        jPanel3.add(jScrollPane1, gridBagConstraints);

        jLabel5.setText(Units.getWeight().getShortName());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(8, 4, 8, 0);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel3.add(jLabel5, gridBagConstraints);

        jTabbedPane1.addTab(I18n.getMsg("generic.propertiesTitle"), jPanel3);

        imageEditor.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        jTabbedPane1.addTab(I18n.getMsg("generic.picture"), imageEditor);

        jPanel1.add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        setVisible(false);
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        try {
            double weight = Utils.parseDouble(weightTextField.getText(), 
                        "generic.invalidWeight");
            setVisible(false);
            bike.setName(nameTextField.getText());
            bike.setDescription(descrTextArea.getText());
            bike.setType(typeComboBox.getSelectedIndex() + 1);
            bike.setWeight(Units.toStdWeight(weight));
            if (imageEditor.isImageChanged())
                bike.setImage(imageEditor.saveImage());
            okPressed = true;
        } catch (Exception e) { 
            JOptionPane.showMessageDialog(this, e.getMessage(),
                    I18n.getMsg("mainWindow.title"), JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_okButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    public static boolean editBike(java.awt.Dialog owner, Bike bike) {
        BikeWindow bw = new BikeWindow(owner, bike, true);
        bw.setVisible(true);
        bw.dispose();
        return bw.okPressed;
    }
    
    public static Bike addBike(java.awt.Dialog owner, ImageStorage is) {
        BikeWindow bw = new BikeWindow(owner, new Bike(is), false);
        bw.setVisible(true);
        boolean res = bw.okPressed;
        bw.dispose();
        return res ? bw.bike : null;
    }    
            
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JTextArea descrTextArea;
    private com.fn.BikersLog.ImageEditor imageEditor;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextField nameTextField;
    private javax.swing.JButton okButton;
    private javax.swing.JComboBox typeComboBox;
    private javax.swing.JTextField weightTextField;
    // End of variables declaration//GEN-END:variables
    
}
