/*
 * DailyGrouper.java
 *
 * Created on 1  2003 ., 18:10
 */

package com.fn.BikersLog;


import java.text.DateFormat;
import java.util.Calendar;
import java.util.Date;


/**
 *
 * @author  asso
 */
public class DailyGrouper implements DateGrouper {
    
    DateFormat dateFormat;
    Calendar calendar;
    
    /** Creates a new instance of DailyGrouper */
    public DailyGrouper() {
        calendar = Calendar.getInstance();
        dateFormat = DateFormat.getDateInstance(DateFormat.SHORT);
    }
    
    public String getGroupLabel(Date d) {
        return dateFormat.format(d);
    }
    
    public boolean isSameGroup(Date d1, Date d2) {
        calendar.setTime(d1);
        int dayNo = calendar.get(Calendar.DAY_OF_MONTH);
        int monthNo = calendar.get(Calendar.MONTH);
        int yearNo = calendar.get(Calendar.YEAR);
        calendar.setTime(d2);
        return ((dayNo == calendar.get(Calendar.DAY_OF_MONTH)) && 
                (monthNo == calendar.get(Calendar.MONTH)) && 
                (yearNo == calendar.get(Calendar.YEAR)));
    }
    
    public Date getNextGroupStart(Date d) {
        calendar.setTime(d);
        calendar.add(Calendar.DAY_OF_MONTH, 1);
        return calendar.getTime();
    }
    
    public Date getPrevGroupStart(Date d) {
        calendar.setTime(d);
        calendar.add(Calendar.DATE, -1);
        return calendar.getTime();
    }
    
    public Date getGroupStart(Date d) {
        return d;
    }
}
