/*
 * EventCell.java
 *
 * Created on 16  2004 ., 10:32
 */

package com.fn.BikersLog;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.text.DateFormat;
import java.util.Calendar;
import java.util.Iterator;
import javax.swing.JComponent;

/**
 *
 * @author  asso
 */
public class EventCell extends JComponent {
    
    private static final int ALIGN_LEFT = 1;
    private static final int ALIGN_RIGHT = 2;
    
    private EventsInDay events;
    private Calendar calendar;
    private DateFormat dateFormat;
    private MicroTable microTable;
    
    /** Creates a new instance of EventCell */
    public EventCell() {
        calendar = Calendar.getInstance();
        dateFormat = DateFormat.getTimeInstance(DateFormat.SHORT);
        microTable = new MicroTable();
    }
    
    public void setData(EventsInDay data) {
        events = data;
        if (null != events)
            calendar.setTime(events.getDay());
        microTable.setModel(events);
    }
    
    private void showEvents(Graphics2D g2, int offset) {
        if  (events.isEmpty())
            return;
        microTable.draw(this, g2, 3, offset, getWidth() - 6, getHeight() - offset);
    }
    
    public void paintComponent(Graphics g) {
        Graphics2D g2 = (Graphics2D)g;
        g2.setPaint(getBackground());
        g2.fillRect(0, 0, getWidth(), getHeight());
        
        if (events != null) {
            String day = Integer.toString(calendar.get(Calendar.DAY_OF_MONTH));
            g2.setPaint(getForeground());
            g2.setFont(Config.getCalendarTitleFont());
            java.awt.FontMetrics metrics = g2.getFontMetrics();
            java.awt.geom.Rectangle2D rect = metrics.getStringBounds(day, g2);
            g2.drawString(day, (float)(getWidth() - 2 - rect.getWidth()), 
                    (float)rect.getHeight());            
            g2.setFont(Config.getCalendarDataFont());
            showEvents(g2, (int)metrics.getHeight() + 2);
        }
    }
}
