/*
 * HeightVertex.java
 *
 * Created on 30  2004 ., 11:03
 */

package com.fn.BikersLog;


import org.w3c.dom.Document;
import org.w3c.dom.Element;


/**
 *
 * @author  asso
 */
public class HeightVertex implements Comparable {

    private String name;
    private double height;
    private double position;
    
    /** Creates a new instance of HeightVertex */
    public HeightVertex() {
        name = "";
        height = 0.0;
        position = 0.0;
    }
    
    public HeightVertex(Element tag) {
        name = DOMUtil.getAttrib(tag, "name", "");
        height = DOMUtil.getAttrib(tag, "height", 0.0);
        position = DOMUtil.getAttrib(tag, "position", 0.0);
    }
    
    public HeightVertex(HeightVertex toClone) {
        name = toClone.name;
        height = toClone.height;
        position = toClone.position;
    }
    
    public HeightVertex(double pos, double height) {
        name = "";
        this.height = height;
        position = pos;
    }
    
    public void save(Document doc, Element parent) {
        Element tag = DOMUtil.addElement(doc, parent, "vertex");
        DOMUtil.setAttrib(tag, "name", name);
        DOMUtil.setAttrib(tag, "height", height);
        DOMUtil.setAttrib(tag, "position", position);
    }
    
    public java.lang.String getName() {
        return name;
    }
    
    public void setName(java.lang.String name) {
        this.name = name;
    }
    
    public double getHeight() {
        return height;
    }
    
    public void setHeight(double height) {
        this.height = height;
    }
    
    public double getPosition() {
        return position;
    }
    
    public void setPosition(double position) {
        this.position = position;
    }
    
    public int compareTo(Object o) {
        HeightVertex v = (HeightVertex)o;
        if (v.position > position)
            return -1;
        else
            if (v.position < position)
                return 1;
            else
                return 0;
    }
}
