/*
 * HeightVertexDialog.java
 *
 * Created on 6  2004 ., 15:56
 */

package com.fn.BikersLog;


import java.text.NumberFormat;
import javax.swing.JOptionPane;


/**
 *
 * @author  asso
 */
public class HeightVertexDialog extends javax.swing.JDialog {
    
    private HeightVertex vertex;
    private boolean okPressed = false;
    
    /** Creates new form HeightVertexDialog */
    public HeightVertexDialog(java.awt.Dialog parent, HeightVertex heightVertex) {
        super(parent, true);
        vertex = heightVertex;
        initComponents();

        nameTextField.setText(vertex.getName());
        positionTextField.setText(Utils.doubleToStr(Units.
                fromStdBDist(vertex.getPosition())));
        heightTextField.setText(Utils.doubleToStr(Units.
                fromStdHeight(vertex.getHeight())));
        
        Utils.centerWindow(this, parent);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        okBtn = new javax.swing.JButton();
        cancelBtn = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        nameTextField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        positionTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        heightTextField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(I18n.getMsg("heightVertexDialog.title"));
        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 8, 8));

        okBtn.setText(I18n.getMsg("generic.ok"));
        okBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okBtnActionPerformed(evt);
            }
        });

        jPanel1.add(okBtn);

        cancelBtn.setText(I18n.getMsg("generic.cancel"));
        cancelBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelBtnActionPerformed(evt);
            }
        });

        jPanel1.add(cancelBtn);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jPanel2.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 0, 8)), new javax.swing.border.TitledBorder(I18n.getMsg("heightVertexDialog.subTitle"))));
        jLabel1.setText(I18n.getMsg("heightVertexDialog.name"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(8, 8, 4, 4);
        jPanel2.add(jLabel1, gridBagConstraints);

        nameTextField.setPreferredSize(new java.awt.Dimension(169, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(8, 4, 4, 4);
        gridBagConstraints.weightx = 1.0;
        jPanel2.add(nameTextField, gridBagConstraints);

        jLabel2.setText(I18n.getMsg("heightVertexDialog.distance"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 8, 4, 4);
        jPanel2.add(jLabel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        gridBagConstraints.weightx = 1.0;
        jPanel2.add(positionTextField, gridBagConstraints);

        jLabel3.setText(I18n.getMsg("heightVertexDialog.height"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 8, 8, 4);
        jPanel2.add(jLabel3, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 8, 4);
        gridBagConstraints.weightx = 1.0;
        jPanel2.add(heightTextField, gridBagConstraints);

        jLabel4.setText(Units.getBDist().getShortName());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 4, 8);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel4, gridBagConstraints);

        jLabel5.setText(Units.getHeight().getShortName());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 8, 8);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel5, gridBagConstraints);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void cancelBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelBtnActionPerformed
        okPressed = false;
        setVisible(false);
    }//GEN-LAST:event_cancelBtnActionPerformed

    private void okBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okBtnActionPerformed
        double position = -1.0;
        try {
            position = NumberFormat.getInstance().parse(positionTextField.getText()).doubleValue();
        } catch (Exception e) { }
        if (position <= 0.0) {
            JOptionPane.showMessageDialog(this, I18n.getMsg("heightVertexDialog.invalidPosition"), 
                I18n.getMsg("mainForm.title"), 
                javax.swing.JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        double height;
        try {
            height = NumberFormat.getInstance().parse(heightTextField.getText()).doubleValue();
        } catch (Exception e) { 
            JOptionPane.showMessageDialog(this, I18n.getMsg("heightVertexDialog.invalidHeight"), 
                I18n.getMsg("mainForm.title"), 
                javax.swing.JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        vertex.setPosition(Units.toStdBDist(position));
        vertex.setHeight(Units.toStdHeight(height));
        
        okPressed = true;
        setVisible(false);
    }//GEN-LAST:event_okBtnActionPerformed

    public static boolean edit(java.awt.Dialog owner, HeightVertex vertex) {
        HeightVertexDialog hvd = new HeightVertexDialog(owner, vertex);
        hvd.setVisible(true);
        return hvd.okPressed;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelBtn;
    private javax.swing.JTextField heightTextField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JTextField nameTextField;
    private javax.swing.JButton okBtn;
    private javax.swing.JTextField positionTextField;
    // End of variables declaration//GEN-END:variables
    
}
