/*
 * ImageChooser.java
 *
 * Created on 24  2004 ., 11:23
 */

package com.fn.BikersLog;


import java.awt.Component;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileInputStream;
import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;


/**
 *
 * @author  asso
 */
public class ImageChooser {
    
    public static class Result {
        public File file;
        public byte[] data;
        public BufferedImage image;
        
        private Result(File f, byte d[], BufferedImage i) throws Exception {
            file = f;
            data = d;
            image = i;
        }
    }
    
    public static Result openImage(Component parent) {
        JFileChooser fc = new JFileChooser();
        fc.addChoosableFileFilter(new ImageFilter());
        fc.setAccessory(new ImagePreview(fc));

        int returnVal = fc.showOpenDialog(parent);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = fc.getSelectedFile();
            try {
                int size = (int)file.length();
                byte data[] = new byte[size];
                FileInputStream is = new FileInputStream(file);
                if (is.read(data) != size)
                    throw new Exception();
                is.close();
                Result res = new Result(file, data, ImageIO.read(file));
                return res;
            } catch (Exception e) {
                JOptionPane.showMessageDialog(parent, I18n.getMsg("openImage.invalidImage"), 
                    I18n.getMsg("mainForm.title"), 
                    javax.swing.JOptionPane.ERROR_MESSAGE);
            }
        }
        return null;
    }
    
}
