/*
 * MainWindow.java
 *
 * Created on 27  2003 ., 12:06
 */

package com.fn.BikersLog;


import java.io.File;
import java.io.FileFilter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.text.DateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import javax.swing.JFileChooser;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;

import com.fn.repway.DataSet;
import com.fn.repway.DataSource;
import com.fn.repway.GeneratedReport;
import com.fn.repway.Preview;
import com.fn.repway.Report;
import com.fn.repway.Value;

/**
 *
 * @author  asso
 */
public class MainWindow extends javax.swing.JFrame {

    private static MainWindow mainWindow;
    private Log log = new Log();
    private int lastFilesMenuStart;
    private int emptyFileMenuSize;
    private EventsView view;
        
    /** Creates new form MainWindow */
    public MainWindow() {
        initGui();
        
        if (Config.getAutoOpenLast()) {
            String lastLogFile = Config.getLastLog();
            if (lastLogFile != null) {
                try {
                    log = new Log(new java.io.File(lastLogFile));
                } catch (Exception e) { }
            }
        }
        
        setupView();
    }
    
    public MainWindow(File file) throws Exception {
        initGui();
        log = new Log(file);
        setupView();
    }
    
    private void initGui() {
        mainWindow = this;
        setIconImage(new javax.swing.ImageIcon(getClass().
                getResource("/com/fn/BikersLog/img/bikerslog.png")).getImage());
        initComponents();
        
        emptyFileMenuSize = fileMenu.getItemCount();
        setBounds(Config.getPosition());
    }
    
    private void setupView() {        
        view = new TableEventsView(log);
        view.install(jPanel1);
        onNewLog();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        viewButtonGroup = new javax.swing.ButtonGroup();
        jToolBar1 = new javax.swing.JToolBar();
        newLogBtn = new javax.swing.JButton();
        openLogBtn = new javax.swing.JButton();
        saveLogBtn = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        addRideBtn = new javax.swing.JButton();
        addCyclotrainerBtn = new javax.swing.JButton();
        addRowingBtn = new javax.swing.JButton();
        addRunningBtn = new javax.swing.JButton();
        addSkiingBtn = new javax.swing.JButton();
        addSwimmingBtn = new javax.swing.JButton();
        addNoteBtn = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        editEventBtn = new javax.swing.JButton();
        deleteEventBtn = new javax.swing.JButton();
        jPanel15 = new javax.swing.JPanel();
        optionBtn = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        menuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        fileNewMenuItem = new javax.swing.JMenuItem();
        fileOpenMenuItem = new javax.swing.JMenuItem();
        fileSaveMenuItem = new javax.swing.JMenuItem();
        fileSaveAsMenuItem = new javax.swing.JMenuItem();
        fileOpenReportMenuItem = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        fileOptionsMenuItem = new javax.swing.JMenuItem();
        startFilesSeparator = new javax.swing.JSeparator();
        endFilesSeparator = new javax.swing.JSeparator();
        fileExitMenuItem = new javax.swing.JMenuItem();
        viewMenu = new javax.swing.JMenu();
        viewTableMenuItem = new javax.swing.JRadioButtonMenuItem();
        viewMonthMenuItem = new javax.swing.JRadioButtonMenuItem();
        activitiesMenu = new javax.swing.JMenu();
        actRideMenuItem = new javax.swing.JMenuItem();
        actCyclotrainerMenuItem = new javax.swing.JMenuItem();
        actRowMenuItem = new javax.swing.JMenuItem();
        actRunningMenuItem = new javax.swing.JMenuItem();
        actSkiingMenuItem = new javax.swing.JMenuItem();
        actSwimmingMenuItem = new javax.swing.JMenuItem();
        actNoteMenuItem = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JSeparator();
        actEditMenuItem = new javax.swing.JMenuItem();
        actDeleteMenuItem = new javax.swing.JMenuItem();
        equipmentMenu = new javax.swing.JMenu();
        eqipBikesMenuItem = new javax.swing.JMenuItem();
        eqipBoatsMenuItem = new javax.swing.JMenuItem();
        eqipSkisMenuItem = new javax.swing.JMenuItem();
        routesMenu = new javax.swing.JMenu();
        routesBikesMenuItem = new javax.swing.JMenuItem();
        routesBoatsMenuItem = new javax.swing.JMenuItem();
        routesRunMenuItem = new javax.swing.JMenuItem();
        routesSkiingMenuItem = new javax.swing.JMenuItem();
        reportsMenu = new javax.swing.JMenu();
        repCyclingMenu = new javax.swing.JMenu();
        reportsRidesMenuItem = new javax.swing.JMenuItem();
        reportsDailyRidesMenuItem = new javax.swing.JMenuItem();
        reportsWeeklyRidesMenuItem = new javax.swing.JMenuItem();
        reportsMonthlyRidesMenuItem = new javax.swing.JMenuItem();
        reportsYearlyRidesMenuItem = new javax.swing.JMenuItem();
        repRowingMenu = new javax.swing.JMenu();
        reportsRowingMenuItem = new javax.swing.JMenuItem();
        reportsDailyRowingMenuItem = new javax.swing.JMenuItem();
        reportsWeeklyRowingMenuItem = new javax.swing.JMenuItem();
        reportsMonthlyRowingMenuItem = new javax.swing.JMenuItem();
        reportsYearlyRowingMenuItem = new javax.swing.JMenuItem();
        repRunningMenu = new javax.swing.JMenu();
        reportsRunningMenuItem = new javax.swing.JMenuItem();
        reportsDailyRunningMenuItem = new javax.swing.JMenuItem();
        reportsWeeklyRunningMenuItem = new javax.swing.JMenuItem();
        reportsMonthlyRunningMenuItem = new javax.swing.JMenuItem();
        reportsYearlyRunningMenuItem = new javax.swing.JMenuItem();
        repSkiingMenu = new javax.swing.JMenu();
        reportsSkiingMenuItem = new javax.swing.JMenuItem();
        reportsDailySkiingMenuItem = new javax.swing.JMenuItem();
        reportsWeeklySkiingMenuItem = new javax.swing.JMenuItem();
        reportsMonthlySkiingMenuItem = new javax.swing.JMenuItem();
        reportsYearlySkiingMenuItem = new javax.swing.JMenuItem();
        repSwimmingMenu = new javax.swing.JMenu();
        reportsSwimmingMenuItem = new javax.swing.JMenuItem();
        reportsDailySwimmingMenuItem = new javax.swing.JMenuItem();
        reportsWeeklySwimmingMenuItem = new javax.swing.JMenuItem();
        reportsMonthlySwimmingMenuItem = new javax.swing.JMenuItem();
        reportsYearlySwimmingMenuItem = new javax.swing.JMenuItem();
        helpMenu = new javax.swing.JMenu();
        helpAboutMenuItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle(I18n.getMsg("mainForm.title"));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jToolBar1.setRollover(true);
        newLogBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/New16.gif")));
        newLogBtn.setToolTipText(I18n.getMsg("mainForm.toolbar.new"));
        newLogBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newLogBtnActionPerformed(evt);
            }
        });

        jToolBar1.add(newLogBtn);

        openLogBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/Open16.gif")));
        openLogBtn.setToolTipText(I18n.getMsg("mainForm.toolbar.open"));
        openLogBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openLogBtnActionPerformed(evt);
            }
        });

        jToolBar1.add(openLogBtn);

        saveLogBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/Save16.gif")));
        saveLogBtn.setToolTipText(I18n.getMsg("mainForm.toolbar.save"));
        saveLogBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveLogBtnActionPerformed(evt);
            }
        });

        jToolBar1.add(saveLogBtn);

        jPanel3.setMaximumSize(new java.awt.Dimension(8, 8));
        jPanel3.setMinimumSize(new java.awt.Dimension(8, 8));
        jPanel3.setPreferredSize(new java.awt.Dimension(8, 8));
        jToolBar1.add(jPanel3);

        addRideBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/addbike.png")));
        addRideBtn.setToolTipText(I18n.getMsg("mainForm.menu.activities.AddRide"));
        addRideBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actRideMenuItemActionPerformed(evt);
            }
        });

        jToolBar1.add(addRideBtn);

        addCyclotrainerBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/addtrainer.png")));
        addCyclotrainerBtn.setToolTipText(I18n.getMsg("mainForm.menu.activities.AddCiclotraining"));
        addCyclotrainerBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actCyclotrainerMenuItemActionPerformed(evt);
            }
        });

        jToolBar1.add(addCyclotrainerBtn);

        addRowingBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/addrowing.png")));
        addRowingBtn.setToolTipText(I18n.getMsg("mainForm.menu.activities.AddRow"));
        addRowingBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actRowMenuItemActionPerformed(evt);
            }
        });

        jToolBar1.add(addRowingBtn);

        addRunningBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/addrunning.png")));
        addRunningBtn.setToolTipText(I18n.getMsg("mainForm.menu.activities.AddRunning"));
        addRunningBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actRunningMenuItemActionPerformed(evt);
            }
        });

        jToolBar1.add(addRunningBtn);

        addSkiingBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/addskiing.png")));
        addSkiingBtn.setToolTipText(I18n.getMsg("mainForm.menu.activities.AddSkiiing"));
        addSkiingBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actSkiingMenuItemActionPerformed(evt);
            }
        });

        jToolBar1.add(addSkiingBtn);

        addSwimmingBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/addswimming.png")));
        addSwimmingBtn.setToolTipText(I18n.getMsg("mainForm.menu.activities.AddSwimming"));
        addSwimmingBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actSwimmingMenuItemActionPerformed(evt);
            }
        });

        jToolBar1.add(addSwimmingBtn);

        addNoteBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/addnote.png")));
        addNoteBtn.setToolTipText(I18n.getMsg("mainForm.menu.activities.AddNote"));
        addNoteBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actNoteMenuItemActionPerformed(evt);
            }
        });

        jToolBar1.add(addNoteBtn);

        jPanel4.setMaximumSize(new java.awt.Dimension(8, 8));
        jPanel4.setMinimumSize(new java.awt.Dimension(8, 8));
        jPanel4.setPreferredSize(new java.awt.Dimension(8, 8));
        jToolBar1.add(jPanel4);

        editEventBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/Edit16.gif")));
        editEventBtn.setToolTipText(I18n.getMsg("mainForm.menu.activities.EditHint"));
        editEventBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actEditMenuItemActionPerformed(evt);
            }
        });

        jToolBar1.add(editEventBtn);

        deleteEventBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/Delete16.gif")));
        deleteEventBtn.setToolTipText(I18n.getMsg("mainForm.menu.activities.DeleteHint"));
        deleteEventBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actDeleteMenuItemActionPerformed(evt);
            }
        });

        jToolBar1.add(deleteEventBtn);

        jPanel15.setMaximumSize(new java.awt.Dimension(8, 8));
        jPanel15.setMinimumSize(new java.awt.Dimension(8, 8));
        jPanel15.setPreferredSize(new java.awt.Dimension(8, 8));
        jToolBar1.add(jPanel15);

        optionBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/Preferences16.gif")));
        optionBtn.setToolTipText(I18n.getMsg("mainForm.toolbar.options"));
        optionBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileOptionsMenuItemActionPerformed(evt);
            }
        });

        jToolBar1.add(optionBtn);

        getContentPane().add(jToolBar1, java.awt.BorderLayout.NORTH);

        jPanel1.setLayout(new java.awt.BorderLayout());

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        fileMenu.setText(I18n.getMsg("mainForm.menu.file"));
        fileNewMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_N, java.awt.event.InputEvent.CTRL_MASK));
        fileNewMenuItem.setText(I18n.getMsg("mainForm.menu.file.new"));
        fileNewMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newLogBtnActionPerformed(evt);
            }
        });

        fileMenu.add(fileNewMenuItem);

        fileOpenMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_MASK));
        fileOpenMenuItem.setText(I18n.getMsg("mainForm.menu.file.open"));
        fileOpenMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openLogBtnActionPerformed(evt);
            }
        });

        fileMenu.add(fileOpenMenuItem);

        fileSaveMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK));
        fileSaveMenuItem.setText(I18n.getMsg("mainForm.menu.file.save"));
        fileSaveMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveLogBtnActionPerformed(evt);
            }
        });

        fileMenu.add(fileSaveMenuItem);

        fileSaveAsMenuItem.setText(I18n.getMsg("mainForm.menu.file.saveAs"));
        fileSaveAsMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileSaveAsMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(fileSaveAsMenuItem);

        fileOpenReportMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_R, java.awt.event.InputEvent.CTRL_MASK));
        fileOpenReportMenuItem.setText(I18n.getMsg("mainForm.menu.file.openReport"));
        fileOpenReportMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileOpenReportMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(fileOpenReportMenuItem);

        fileMenu.add(jSeparator1);

        fileOptionsMenuItem.setText(I18n.getMsg("mainForm.menu.file.options"));
        fileOptionsMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileOptionsMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(fileOptionsMenuItem);

        lastFilesMenuStart = fileMenu.getItemCount() + 1;
        fileMenu.add(startFilesSeparator);

        fileMenu.add(endFilesSeparator);

        fileExitMenuItem.setText(I18n.getMsg("mainForm.menu.file.exit"));
        fileExitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileExitMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(fileExitMenuItem);

        menuBar.add(fileMenu);

        viewMenu.setText(I18n.getMsg("mainForm.menu.view"));
        viewTableMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_1, java.awt.event.InputEvent.CTRL_MASK));
        viewTableMenuItem.setSelected(true);
        viewTableMenuItem.setText(I18n.getMsg("mainForm.menu.view.table"));
        viewButtonGroup.add(viewTableMenuItem);
        viewTableMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                viewTableMenuItemActionPerformed(evt);
            }
        });

        viewMenu.add(viewTableMenuItem);

        viewMonthMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_2, java.awt.event.InputEvent.CTRL_MASK));
        viewMonthMenuItem.setText(I18n.getMsg("mainForm.menu.view.month"));
        viewButtonGroup.add(viewMonthMenuItem);
        viewMonthMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                viewMonthMenuItemActionPerformed(evt);
            }
        });

        viewMenu.add(viewMonthMenuItem);

        menuBar.add(viewMenu);

        activitiesMenu.setText(I18n.getMsg("mainForm.menu.activities"));
        actRideMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.event.InputEvent.ALT_MASK));
        actRideMenuItem.setText(I18n.getMsg("mainForm.menu.activities.AddRide"));
        actRideMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actRideMenuItemActionPerformed(evt);
            }
        });

        activitiesMenu.add(actRideMenuItem);

        actCyclotrainerMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_T, java.awt.event.InputEvent.ALT_MASK));
        actCyclotrainerMenuItem.setText(I18n.getMsg("mainForm.menu.activities.AddCiclotraining"));
        actCyclotrainerMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actCyclotrainerMenuItemActionPerformed(evt);
            }
        });

        activitiesMenu.add(actCyclotrainerMenuItem);

        actRowMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_R, java.awt.event.InputEvent.ALT_MASK));
        actRowMenuItem.setText(I18n.getMsg("mainForm.menu.activities.AddRow"));
        actRowMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actRowMenuItemActionPerformed(evt);
            }
        });

        activitiesMenu.add(actRowMenuItem);

        actRunningMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_U, java.awt.event.InputEvent.ALT_MASK));
        actRunningMenuItem.setText(I18n.getMsg("mainForm.menu.activities.AddRunning"));
        actRunningMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actRunningMenuItemActionPerformed(evt);
            }
        });

        activitiesMenu.add(actRunningMenuItem);

        actSkiingMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.ALT_MASK));
        actSkiingMenuItem.setText(I18n.getMsg("mainForm.menu.activities.AddSkiiing"));
        actSkiingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actSkiingMenuItemActionPerformed(evt);
            }
        });

        activitiesMenu.add(actSkiingMenuItem);

        actSwimmingMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_W, java.awt.event.InputEvent.ALT_MASK));
        actSwimmingMenuItem.setText(I18n.getMsg("mainForm.menu.activities.AddSwimming"));
        actSwimmingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actSwimmingMenuItemActionPerformed(evt);
            }
        });

        activitiesMenu.add(actSwimmingMenuItem);

        actNoteMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_N, java.awt.event.InputEvent.ALT_MASK));
        actNoteMenuItem.setText(I18n.getMsg("mainForm.menu.activities.AddNote"));
        actNoteMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actNoteMenuItemActionPerformed(evt);
            }
        });

        activitiesMenu.add(actNoteMenuItem);

        activitiesMenu.add(jSeparator2);

        actEditMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F4, 0));
        actEditMenuItem.setText(I18n.getMsg("mainForm.menu.activities.Edit"));
        actEditMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actEditMenuItemActionPerformed(evt);
            }
        });

        activitiesMenu.add(actEditMenuItem);

        actDeleteMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F8, 0));
        actDeleteMenuItem.setText(I18n.getMsg("mainForm.menu.activities.Delete"));
        actDeleteMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actDeleteMenuItemActionPerformed(evt);
            }
        });

        activitiesMenu.add(actDeleteMenuItem);

        menuBar.add(activitiesMenu);

        equipmentMenu.setText(I18n.getMsg("mainForm.menu.eqipment"));
        eqipBikesMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.event.InputEvent.CTRL_MASK));
        eqipBikesMenuItem.setText(I18n.getMsg("mainForm.menu.eqipment.bikes"));
        eqipBikesMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                eqipBikesMenuItemActionPerformed(evt);
            }
        });

        equipmentMenu.add(eqipBikesMenuItem);

        eqipBoatsMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_B, java.awt.event.InputEvent.CTRL_MASK));
        eqipBoatsMenuItem.setText(I18n.getMsg("mainForm.menu.eqipment.boats"));
        eqipBoatsMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                eqipBoatsMenuItemActionPerformed(evt);
            }
        });

        equipmentMenu.add(eqipBoatsMenuItem);

        eqipSkisMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_I, java.awt.event.InputEvent.CTRL_MASK));
        eqipSkisMenuItem.setText(I18n.getMsg("mainForm.menu.eqipment.skis"));
        eqipSkisMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                eqipSkisMenuItemActionPerformed(evt);
            }
        });

        equipmentMenu.add(eqipSkisMenuItem);

        menuBar.add(equipmentMenu);

        routesMenu.setText(I18n.getMsg("mainForm.menu.routes"));
        routesBikesMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_V, java.awt.event.InputEvent.CTRL_MASK));
        routesBikesMenuItem.setText(I18n.getMsg("mainForm.menu.routes.bikes"));
        routesBikesMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                routesBikesMenuItemActionPerformed(evt);
            }
        });

        routesMenu.add(routesBikesMenuItem);

        routesBoatsMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_W, java.awt.event.InputEvent.CTRL_MASK));
        routesBoatsMenuItem.setText(I18n.getMsg("mainForm.menu.routes.boats"));
        routesBoatsMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                routesBoatsMenuItemActionPerformed(evt);
            }
        });

        routesMenu.add(routesBoatsMenuItem);

        routesRunMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_U, java.awt.event.InputEvent.CTRL_MASK));
        routesRunMenuItem.setText(I18n.getMsg("mainForm.menu.routes.run"));
        routesRunMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                routesRunMenuItemActionPerformed(evt);
            }
        });

        routesMenu.add(routesRunMenuItem);

        routesSkiingMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_K, java.awt.event.InputEvent.CTRL_MASK));
        routesSkiingMenuItem.setText(I18n.getMsg("mainForm.menu.routes.skiing"));
        routesSkiingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                routesSkiingMenuItemActionPerformed(evt);
            }
        });

        routesMenu.add(routesSkiingMenuItem);

        menuBar.add(routesMenu);

        reportsMenu.setText(I18n.getMsg("mainForm.menu.reports"));
        repCyclingMenu.setText(I18n.getMsg("mainForm.menu.reports.Cycling"));
        reportsRidesMenuItem.setText(I18n.getMsg("mainForm.menu.reports.rides"));
        reportsRidesMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsRidesMenuItemActionPerformed(evt);
            }
        });

        repCyclingMenu.add(reportsRidesMenuItem);

        reportsDailyRidesMenuItem.setText(I18n.getMsg("mainForm.menu.reports.daily"));
        reportsDailyRidesMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsDailyRidesMenuItemActionPerformed(evt);
            }
        });

        repCyclingMenu.add(reportsDailyRidesMenuItem);

        reportsWeeklyRidesMenuItem.setText(I18n.getMsg("mainForm.menu.reports.weekly"));
        reportsWeeklyRidesMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsWeeklyRidesMenuItemActionPerformed(evt);
            }
        });

        repCyclingMenu.add(reportsWeeklyRidesMenuItem);

        reportsMonthlyRidesMenuItem.setText(I18n.getMsg("mainForm.menu.reports.monthly"));
        reportsMonthlyRidesMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsMonthlyRidesMenuItemActionPerformed(evt);
            }
        });

        repCyclingMenu.add(reportsMonthlyRidesMenuItem);

        reportsYearlyRidesMenuItem.setText(I18n.getMsg("mainForm.menu.reports.yearly"));
        reportsYearlyRidesMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsYearlyRidesMenuItemActionPerformed(evt);
            }
        });

        repCyclingMenu.add(reportsYearlyRidesMenuItem);

        reportsMenu.add(repCyclingMenu);

        repRowingMenu.setText(I18n.getMsg("mainForm.menu.reports.rowing"));
        reportsRowingMenuItem.setText(I18n.getMsg("mainForm.menu.reports.rowing.events"));
        reportsRowingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsRowingMenuItemActionPerformed(evt);
            }
        });

        repRowingMenu.add(reportsRowingMenuItem);

        reportsDailyRowingMenuItem.setText(I18n.getMsg("mainForm.menu.reports.rowing.daily"));
        reportsDailyRowingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsDailyRowingMenuItemActionPerformed(evt);
            }
        });

        repRowingMenu.add(reportsDailyRowingMenuItem);

        reportsWeeklyRowingMenuItem.setText(I18n.getMsg("mainForm.menu.reports.rowing.weekly"));
        reportsWeeklyRowingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsWeeklyRowingMenuItemActionPerformed(evt);
            }
        });

        repRowingMenu.add(reportsWeeklyRowingMenuItem);

        reportsMonthlyRowingMenuItem.setText(I18n.getMsg("mainForm.menu.reports.rowing.monthly"));
        reportsMonthlyRowingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsMonthlyRowingMenuItemActionPerformed(evt);
            }
        });

        repRowingMenu.add(reportsMonthlyRowingMenuItem);

        reportsYearlyRowingMenuItem.setText(I18n.getMsg("mainForm.menu.reports.rowing.yearly"));
        reportsYearlyRowingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsYearlyRowingMenuItemActionPerformed(evt);
            }
        });

        repRowingMenu.add(reportsYearlyRowingMenuItem);

        reportsMenu.add(repRowingMenu);

        repRunningMenu.setText(I18n.getMsg("mainForm.menu.reports.running"));
        reportsRunningMenuItem.setText(I18n.getMsg("mainForm.menu.reports.rowing.events"));
        reportsRunningMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsRunningMenuItemActionPerformed(evt);
            }
        });

        repRunningMenu.add(reportsRunningMenuItem);

        reportsDailyRunningMenuItem.setText(I18n.getMsg("mainForm.menu.reports.running.daily"));
        reportsDailyRunningMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsDailyRunningMenuItemActionPerformed(evt);
            }
        });

        repRunningMenu.add(reportsDailyRunningMenuItem);

        reportsWeeklyRunningMenuItem.setText(I18n.getMsg("mainForm.menu.reports.running.weekly"));
        reportsWeeklyRunningMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsWeeklyRunningMenuItemActionPerformed(evt);
            }
        });

        repRunningMenu.add(reportsWeeklyRunningMenuItem);

        reportsMonthlyRunningMenuItem.setText(I18n.getMsg("mainForm.menu.reports.running.monthly"));
        reportsMonthlyRunningMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsMonthlyRunningMenuItemActionPerformed(evt);
            }
        });

        repRunningMenu.add(reportsMonthlyRunningMenuItem);

        reportsYearlyRunningMenuItem.setText(I18n.getMsg("mainForm.menu.reports.running.yearly"));
        reportsYearlyRunningMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsYearlyRunningMenuItemActionPerformed(evt);
            }
        });

        repRunningMenu.add(reportsYearlyRunningMenuItem);

        reportsMenu.add(repRunningMenu);

        repSkiingMenu.setText(I18n.getMsg("mainForm.menu.reports.skiing"));
        reportsSkiingMenuItem.setText(I18n.getMsg("mainForm.menu.reports.rowing.events"));
        reportsSkiingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsSkiingMenuItemActionPerformed(evt);
            }
        });

        repSkiingMenu.add(reportsSkiingMenuItem);

        reportsDailySkiingMenuItem.setText(I18n.getMsg("mainForm.menu.reports.skiing.daily"));
        reportsDailySkiingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsDailySkiingMenuItemActionPerformed(evt);
            }
        });

        repSkiingMenu.add(reportsDailySkiingMenuItem);

        reportsWeeklySkiingMenuItem.setText(I18n.getMsg("mainForm.menu.reports.skiing.weekly"));
        reportsWeeklySkiingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsWeeklySkiingMenuItemActionPerformed(evt);
            }
        });

        repSkiingMenu.add(reportsWeeklySkiingMenuItem);

        reportsMonthlySkiingMenuItem.setText(I18n.getMsg("mainForm.menu.reports.skiing.monthly"));
        reportsMonthlySkiingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsMonthlySkiingMenuItemActionPerformed(evt);
            }
        });

        repSkiingMenu.add(reportsMonthlySkiingMenuItem);

        reportsYearlySkiingMenuItem.setText(I18n.getMsg("mainForm.menu.reports.skiing.yearly"));
        reportsYearlySkiingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsYearlySkiingMenuItemActionPerformed(evt);
            }
        });

        repSkiingMenu.add(reportsYearlySkiingMenuItem);

        reportsMenu.add(repSkiingMenu);

        repSwimmingMenu.setText(I18n.getMsg("mainForm.menu.reports.swimming"));
        reportsSwimmingMenuItem.setText(I18n.getMsg("mainForm.menu.reports.rowing.events"));
        reportsSwimmingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsSwimmingMenuItemActionPerformed(evt);
            }
        });

        repSwimmingMenu.add(reportsSwimmingMenuItem);

        reportsDailySwimmingMenuItem.setText(I18n.getMsg("mainForm.menu.reports.swimming.daily"));
        reportsDailySwimmingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsDailySwimmingMenuItemActionPerformed(evt);
            }
        });

        repSwimmingMenu.add(reportsDailySwimmingMenuItem);

        reportsWeeklySwimmingMenuItem.setText(I18n.getMsg("mainForm.menu.reports.swimming.weekly"));
        reportsWeeklySwimmingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsWeeklySwimmingMenuItemActionPerformed(evt);
            }
        });

        repSwimmingMenu.add(reportsWeeklySwimmingMenuItem);

        reportsMonthlySwimmingMenuItem.setText(I18n.getMsg("mainForm.menu.reports.swimming.monthly"));
        reportsMonthlySwimmingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsMonthlySwimmingMenuItemActionPerformed(evt);
            }
        });

        repSwimmingMenu.add(reportsMonthlySwimmingMenuItem);

        reportsYearlySwimmingMenuItem.setText(I18n.getMsg("mainForm.menu.reports.swimming.yearly"));
        reportsYearlySwimmingMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportsYearlySwimmingMenuItemActionPerformed(evt);
            }
        });

        repSwimmingMenu.add(reportsYearlySwimmingMenuItem);

        reportsMenu.add(repSwimmingMenu);

        menuBar.add(reportsMenu);

        helpMenu.setText(I18n.getMsg("mainForm.menu.help"));
        helpAboutMenuItem.setText(I18n.getMsg("mainForm.menu.help.about"));
        helpAboutMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                helpAboutMenuItemActionPerformed(evt);
            }
        });

        helpMenu.add(helpAboutMenuItem);

        menuBar.add(helpMenu);

        setJMenuBar(menuBar);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-493)/2, (screenSize.height-402)/2, 493, 402);
    }//GEN-END:initComponents

    private void reportsSwimmingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsSwimmingMenuItemActionPerformed
        DateInterval di = DateIntervalWindow.execute(this, 
                Utils.subMonth(new Date()), new Date());
        if (di != null) {
            try {
                Report report = loadReport("swimming/events.urp");
                DataSet ds = new SwimmingDataSet(log.getEventsList(), di.getFromDate(), di.getToDate());
                Map params = createIntervalParams(di);
                showReportPreviewWindow(report, ds, params);
            } catch (Exception e) {
                System.out.println(e.getMessage());
                e.printStackTrace();
            }
        }
    }//GEN-LAST:event_reportsSwimmingMenuItemActionPerformed

    private void reportsSkiingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsSkiingMenuItemActionPerformed
        DateInterval di = DateIntervalWindow.execute(this, 
                Utils.subMonth(new Date()), new Date());
        if (di != null) {
            try {
                Report report = loadReport("skiing/events.urp");
                DataSet ds = new SkiingDataSet(log.getEventsList(), di.getFromDate(), di.getToDate());
                Map params = createIntervalParams(di);
                showReportPreviewWindow(report, ds, params);
            } catch (Exception e) {
                System.out.println(e.getMessage());
                e.printStackTrace();
            }
        }
    }//GEN-LAST:event_reportsSkiingMenuItemActionPerformed

    private void reportsRunningMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsRunningMenuItemActionPerformed
        DateInterval di = DateIntervalWindow.execute(this, 
                Utils.subMonth(new Date()), new Date());
        if (di != null) {
            try {
                Report report = loadReport("running/events.urp");
                DataSet ds = new RunningDataSet(log.getEventsList(), di.getFromDate(), di.getToDate());
                Map params = createIntervalParams(di);
                showReportPreviewWindow(report, ds, params);
            } catch (Exception e) {
                System.out.println(e.getMessage());
                e.printStackTrace();
            }
        }
    }//GEN-LAST:event_reportsRunningMenuItemActionPerformed

    private void reportsRowingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsRowingMenuItemActionPerformed
        DateInterval di = DateIntervalWindow.execute(this, 
                Utils.subMonth(new Date()), new Date());
        if (di != null) {
            try {
                Report report = loadReport("rowing/events.urp");
                DataSet ds = new RowingDataSet(log.getEventsList(), di.getFromDate(), di.getToDate());
                Map params = createIntervalParams(di);
                showReportPreviewWindow(report, ds, params);
            } catch (Exception e) {
                System.out.println(e.getMessage());
                e.printStackTrace();
            }
        }
    }//GEN-LAST:event_reportsRowingMenuItemActionPerformed
    
    private DataSource createGroupedSwimmingSource(DateInterval interval, 
                DateGrouper grouper, boolean createEmptyGroups)
    {
        DataSource ds = new DataSource();
        ds.addDataSet(new GroupedSwimmingDataSet(log.getEventsList(), 
                interval.getFromDate(), interval.getToDate(), "rides", 
                grouper, createEmptyGroups));
        return ds;
    }
    
    private void swimmingDstReport(DateGrouper grouper, DateInterval interval, 
            boolean empty, String name)
    {
        try {
            Report report = loadReport("dst.urp");
            DataSource ds = createGroupedSwimmingSource(interval, grouper, empty);
            Map params = createIntervalParams(interval);
            params.put("title", new Value(I18n.getMsg(name)));
            showReportPreviewWindow(report, ds, params);
        } catch (Exception e) {
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
    }

    private void reportsYearlySwimmingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsYearlySwimmingMenuItemActionPerformed
        DateInterval di = YearIntervalWindow.execute(this);
        if (di != null) 
            swimmingDstReport(new AnnualGrouper(), di, true, "reports.annualSwimming");
    }//GEN-LAST:event_reportsYearlySwimmingMenuItemActionPerformed

    private void reportsMonthlySwimmingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsMonthlySwimmingMenuItemActionPerformed
        DateInterval di = MonthIntervalWindow.execute(this);
        if (di != null)
            swimmingDstReport(new MonthlyGrouper(), di, true, "reports.monthlySwimming");
    }//GEN-LAST:event_reportsMonthlySwimmingMenuItemActionPerformed

    private void reportsWeeklySwimmingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsWeeklySwimmingMenuItemActionPerformed
        DateInterval di = DateIntervalWindow.execute(this, 
                Utils.subMonth(new Date()), new Date());
        if (di != null)
            swimmingDstReport(new WeeklyGrouper(), di, true, "reports.weeklySwimming");
    }//GEN-LAST:event_reportsWeeklySwimmingMenuItemActionPerformed

    private void reportsDailySwimmingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsDailySwimmingMenuItemActionPerformed
        DateInterval di = DateIntervalWindow.execute(this, 
                Utils.subMonth(new Date()), new Date());
        if (di != null)
            swimmingDstReport(new DailyGrouper(), di, false, "reports.dailySwimming");
    }//GEN-LAST:event_reportsDailySwimmingMenuItemActionPerformed
    
    private DataSource createGroupedSkiingSource(DateInterval interval, 
                DateGrouper grouper, boolean createEmptyGroups)
    {
        DataSource ds = new DataSource();
        ds.addDataSet(new GroupedSkiingDataSet(log.getEventsList(), 
                interval.getFromDate(), interval.getToDate(), "rides", 
                grouper, createEmptyGroups));
        return ds;
    }
    
    private void skiingDstReport(DateGrouper grouper, DateInterval interval, 
            boolean empty, String name)
    {
        try {
            Report report = loadReport("dst.urp");
            DataSource ds = createGroupedSkiingSource(interval, grouper, empty);
            Map params = createIntervalParams(interval);
            params.put("title", new Value(I18n.getMsg(name)));
            showReportPreviewWindow(report, ds, params);
        } catch (Exception e) {
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
    }

    private void reportsYearlySkiingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsYearlySkiingMenuItemActionPerformed
        DateInterval di = YearIntervalWindow.execute(this);
        if (di != null) 
            skiingDstReport(new AnnualGrouper(), di, true, "reports.annualSkiing");
    }//GEN-LAST:event_reportsYearlySkiingMenuItemActionPerformed

    private void reportsMonthlySkiingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsMonthlySkiingMenuItemActionPerformed
        DateInterval di = MonthIntervalWindow.execute(this);
        if (di != null)
            skiingDstReport(new MonthlyGrouper(), di, true, "reports.monthlySkiing");
    }//GEN-LAST:event_reportsMonthlySkiingMenuItemActionPerformed

    private void reportsWeeklySkiingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsWeeklySkiingMenuItemActionPerformed
        DateInterval di = DateIntervalWindow.execute(this, 
                Utils.subMonth(new Date()), new Date());
        if (di != null)
            skiingDstReport(new WeeklyGrouper(), di, true, "reports.weeklySkiing");
    }//GEN-LAST:event_reportsWeeklySkiingMenuItemActionPerformed

    private void reportsDailySkiingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsDailySkiingMenuItemActionPerformed
        DateInterval di = DateIntervalWindow.execute(this, 
                Utils.subMonth(new Date()), new Date());
        if (di != null)
            skiingDstReport(new DailyGrouper(), di, false, "reports.dailySkiing");
    }//GEN-LAST:event_reportsDailySkiingMenuItemActionPerformed
    
    private DataSource createGroupedRunningSource(DateInterval interval, 
                DateGrouper grouper, boolean createEmptyGroups)
    {
        DataSource ds = new DataSource();
        ds.addDataSet(new GroupedRunningDataSet(log.getEventsList(), 
                interval.getFromDate(), interval.getToDate(), "rides", 
                grouper, createEmptyGroups));
        return ds;
    }
    
    private void runningDstReport(DateGrouper grouper, DateInterval interval, 
            boolean empty, String name)
    {
        try {
            Report report = loadReport("dst.urp");
            DataSource ds = createGroupedRunningSource(interval, grouper, empty);
            Map params = createIntervalParams(interval);
            params.put("title", new Value(I18n.getMsg(name)));
            showReportPreviewWindow(report, ds, params);
        } catch (Exception e) {
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
    }
    
    private void reportsYearlyRunningMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsYearlyRunningMenuItemActionPerformed
        DateInterval di = YearIntervalWindow.execute(this);
        if (di != null) 
            runningDstReport(new AnnualGrouper(), di, true, "reports.annualRunning");
    }//GEN-LAST:event_reportsYearlyRunningMenuItemActionPerformed

    private void reportsMonthlyRunningMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsMonthlyRunningMenuItemActionPerformed
        DateInterval di = MonthIntervalWindow.execute(this);
        if (di != null)
            runningDstReport(new MonthlyGrouper(), di, true, "reports.monthlyRunning");
    }//GEN-LAST:event_reportsMonthlyRunningMenuItemActionPerformed

    private void reportsWeeklyRunningMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsWeeklyRunningMenuItemActionPerformed
        DateInterval di = DateIntervalWindow.execute(this, 
                Utils.subMonth(new Date()), new Date());
        if (di != null)
            runningDstReport(new WeeklyGrouper(), di, true, "reports.weeklyRunning");
    }//GEN-LAST:event_reportsWeeklyRunningMenuItemActionPerformed

    private void reportsDailyRunningMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsDailyRunningMenuItemActionPerformed
        DateInterval di = DateIntervalWindow.execute(this, 
                Utils.subMonth(new Date()), new Date());
        if (di != null)
            runningDstReport(new DailyGrouper(), di, false, "reports.dailyRunning");
    }//GEN-LAST:event_reportsDailyRunningMenuItemActionPerformed
    
    private DataSource createGroupedRowingSource(DateInterval interval, 
                DateGrouper grouper, boolean createEmptyGroups)
    {
        DataSource ds = new DataSource();
        ds.addDataSet(new GroupedRowingDataSet(log.getEventsList(), 
                interval.getFromDate(), interval.getToDate(), "rides", 
                grouper, createEmptyGroups));
        return ds;
    }
    
    private void rowingDstReport(DateGrouper grouper, DateInterval interval, 
            boolean empty, String name)
    {
        try {
            Report report = loadReport("dst.urp");
            DataSource ds = createGroupedRowingSource(interval, grouper, empty);
            Map params = createIntervalParams(interval);
            params.put("title", new Value(I18n.getMsg(name)));
            showReportPreviewWindow(report, ds, params);
        } catch (Exception e) {
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
    }

    private void reportsYearlyRowingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsYearlyRowingMenuItemActionPerformed
        DateInterval di = YearIntervalWindow.execute(this);
        if (di != null) 
            rowingDstReport(new AnnualGrouper(), di, true, "reports.annualRowing");
    }//GEN-LAST:event_reportsYearlyRowingMenuItemActionPerformed

    private void reportsMonthlyRowingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsMonthlyRowingMenuItemActionPerformed
        DateInterval di = MonthIntervalWindow.execute(this);
        if (di != null)
            rowingDstReport(new MonthlyGrouper(), di, true, "reports.monthlyRowing");
    }//GEN-LAST:event_reportsMonthlyRowingMenuItemActionPerformed

    private void reportsWeeklyRowingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsWeeklyRowingMenuItemActionPerformed
        DateInterval di = DateIntervalWindow.execute(this, 
                Utils.subMonth(new Date()), new Date());
        if (di != null)
            rowingDstReport(new WeeklyGrouper(), di, true, "reports.weeklyRowing");
    }//GEN-LAST:event_reportsWeeklyRowingMenuItemActionPerformed
    
    private void reportsDailyRowingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsDailyRowingMenuItemActionPerformed
        DateInterval di = DateIntervalWindow.execute(this, 
                Utils.subMonth(new Date()), new Date());
        if (di != null)
            rowingDstReport(new DailyGrouper(), di, false, "reports.dailyRowing");
    }//GEN-LAST:event_reportsDailyRowingMenuItemActionPerformed

    private void actSwimmingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actSwimmingMenuItemActionPerformed
        SwimmingEvent event = SwimmingWindow.add(this, log, view.getNewEventDate());
        if (null != event) {
            view.setSelectedIndex(log.getEventsList().add(event));
            log.markAsUnsaved();
        }
    }//GEN-LAST:event_actSwimmingMenuItemActionPerformed

    private void actSkiingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actSkiingMenuItemActionPerformed
        if (log.getRunRoutesList().getSize() < 1) {
            JOptionPane.showMessageDialog(this, I18n.getMsg("mainForm.messages.runningRoutesNotFound"));
            return;
        }
        SkiingEvent event = SkiingWindow.add(this, log, view.getNewEventDate());
        if (null != event) {
            view.setSelectedIndex(log.getEventsList().add(event));
            log.markAsUnsaved();
        }
    }//GEN-LAST:event_actSkiingMenuItemActionPerformed

    private void routesSkiingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_routesSkiingMenuItemActionPerformed
        SkiingRoutesListWindow.execute(this, log);
    }//GEN-LAST:event_routesSkiingMenuItemActionPerformed

    private void eqipSkisMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_eqipSkisMenuItemActionPerformed
        SkisListWindow.execute(this, log);
    }//GEN-LAST:event_eqipSkisMenuItemActionPerformed

    private void actRunningMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actRunningMenuItemActionPerformed
        if (log.getRunRoutesList().getSize() < 1) {
            JOptionPane.showMessageDialog(this, I18n.getMsg("mainForm.messages.runningRoutesNotFound"));
            return;
        }
        RunningEvent event = RunningWindow.add(this, log, view.getNewEventDate());
        if (null != event) {
            view.setSelectedIndex(log.getEventsList().add(event));
            log.markAsUnsaved();
        }
    }//GEN-LAST:event_actRunningMenuItemActionPerformed

    private void routesRunMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_routesRunMenuItemActionPerformed
        RunRoutesListWindow.execute(this, log);
    }//GEN-LAST:event_routesRunMenuItemActionPerformed

    private void actRowMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actRowMenuItemActionPerformed
        if (log.getBoatsList().getSize() < 1) {
            JOptionPane.showMessageDialog(this, I18n.getMsg("mainForm.messages.boatsNotFound"));
            return;
        }
        if (log.getAquaRoutesList().getSize() < 1) {
            JOptionPane.showMessageDialog(this, I18n.getMsg("mainForm.messages.aquaRoutesNotFound"));
            return;
        }
        RowingEvent event = RowingWindow.add(this, log, view.getNewEventDate());
        if (null != event) {
            view.setSelectedIndex(log.getEventsList().add(event));
            log.markAsUnsaved();
        }
    }//GEN-LAST:event_actRowMenuItemActionPerformed

    private void routesBoatsMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_routesBoatsMenuItemActionPerformed
        AquaRoutesListWindow.execute(this, log);
    }//GEN-LAST:event_routesBoatsMenuItemActionPerformed

    private void viewMonthMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_viewMonthMenuItemActionPerformed
        if (null != view) {
            if (view instanceof CalendarView)
                return;
            view.remove();
        }
        view = new CalendarView(log);
        view.install(jPanel1);
        jPanel1.validate();
    }//GEN-LAST:event_viewMonthMenuItemActionPerformed

    private void viewTableMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_viewTableMenuItemActionPerformed
        if (null != view) {
            if (view instanceof TableEventsView)
                return;
            view.remove();
        }
        view = new TableEventsView(log);
        view.install(jPanel1);
        jPanel1.validate();
    }//GEN-LAST:event_viewTableMenuItemActionPerformed

    public void deleteEvent() {
        Event selected = view.getSelected(false);
        if (null != selected) {
            int res = JOptionPane.showConfirmDialog(this, 
                    I18n.getMsg("mainForm.events.deleteConfirmation"),
                    I18n.getMsg("mainForm.title"), JOptionPane.YES_NO_OPTION);
            if (res == JOptionPane.YES_OPTION) {
                int idx = log.getEventsList().getIndexOf(selected);
                log.getEventsList().delete(idx);
                log.markAsUnsaved();
                if (log.getEventsList().getSize() <= idx)
                    idx--;
                if (idx >= 0)
                    view.setSelectedIndex(idx);
            }
        }
    }
    
    private void actDeleteMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actDeleteMenuItemActionPerformed
        deleteEvent();
    }//GEN-LAST:event_actDeleteMenuItemActionPerformed

    public void editEvent() {
        Event selected = view.getSelected(true);
        if (null != selected) {
            boolean res = false;
            if (selected instanceof RideEvent)
                res = RideWindow.editRide(this, (RideEvent)selected, log);
            else if (selected instanceof NoteEvent)
                res = NoteWindow.editNote(this, (NoteEvent)selected);
            else if (selected instanceof CycleTrainerEvent)
                res = (CyclotrainerWindow.editTraining(this, (CycleTrainerEvent)selected));
            else if (selected instanceof RowingEvent) 
                res = RowingWindow.edit(this, (RowingEvent)selected, log);
            else if (selected instanceof RunningEvent) 
                res = RunningWindow.edit(this, (RunningEvent)selected, log);
            else if (selected instanceof SkiingEvent) 
                res = SkiingWindow.edit(this, (SkiingEvent)selected, log);
            else if (selected instanceof SwimmingEvent) 
                res = SwimmingWindow.edit(this, (SwimmingEvent)selected, log);
            if (res) {
                view.setSelectedIndex(log.getEventsList().change(selected));
                log.markAsUnsaved();
            }
        }
    }
    
    private void actEditMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actEditMenuItemActionPerformed
        editEvent();
    }//GEN-LAST:event_actEditMenuItemActionPerformed

    private void actNoteMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actNoteMenuItemActionPerformed
        NoteEvent event = NoteWindow.addNote(this, view.getNewEventDate());
        if (event != null) {
            view.setSelectedIndex(log.getEventsList().add(event));
            log.markAsUnsaved();
        }        
    }//GEN-LAST:event_actNoteMenuItemActionPerformed

    private void actCyclotrainerMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actCyclotrainerMenuItemActionPerformed
        CycleTrainerEvent event = CyclotrainerWindow.addTraining(this, view.getNewEventDate());
        if (event != null) {
            view.setSelectedIndex(log.getEventsList().add(event));
            log.markAsUnsaved();
        }
    }//GEN-LAST:event_actCyclotrainerMenuItemActionPerformed

    private void actRideMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actRideMenuItemActionPerformed
        if (log.getBikesList().getSize() < 1) {
            JOptionPane.showMessageDialog(this, I18n.getMsg("mainForm.messages.bikesNotFound"));
            return;
        }
        if (log.getCoursesList().getSize() < 1) {
            JOptionPane.showMessageDialog(this, I18n.getMsg("mainForm.messages.coursesNotFound"));
            return;
        }
        RideEvent event = RideWindow.addRide(this, log, view.getNewEventDate());
        if (event != null) {
            view.setSelectedIndex(log.getEventsList().add(event));
            log.markAsUnsaved();
        }
    }//GEN-LAST:event_actRideMenuItemActionPerformed

    private void routesBikesMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_routesBikesMenuItemActionPerformed
        BikeRoutesListWindow.execute(this, log);
    }//GEN-LAST:event_routesBikesMenuItemActionPerformed

    private void eqipBikesMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_eqipBikesMenuItemActionPerformed
        BikesListWindow.execute(this, log);
    }//GEN-LAST:event_eqipBikesMenuItemActionPerformed

    private void eqipBoatsMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_eqipBoatsMenuItemActionPerformed
        BoatsListWindow.execute(this, log);
    }//GEN-LAST:event_eqipBoatsMenuItemActionPerformed

    private Report loadReport(String name) throws Exception {
        InputStream is = Utils.getIntlResource("/com/fn/BikersLog/reports/" + name);
        Report report = new Report(new java.io.InputStreamReader(is, "UTF-8"));
        is.close();
        return report;
    }
    
    private Map createIntervalParams(DateInterval interval) {
        Map params = new HashMap();
        DateFormat df = DateFormat.getDateInstance(DateFormat.SHORT);
        params.put("from", new Value(df.format(interval.getFromDate())));
        params.put("to", new Value(df.format(interval.getToDate())));
        return params;
    }
    
    private DataSource createGroupedCyclingSource(DateInterval interval, 
                DateGrouper grouper, boolean createEmptyGroups)
    {
        DataSource ds = new DataSource();
        ds.addDataSet(new GroupedRidesDataSet(log.getEventsList(), 
                interval.getFromDate(), interval.getToDate(), "rides", 
                grouper, createEmptyGroups));
        return ds;
    }
    
    private void cyclingDstReport(DateGrouper grouper, DateInterval interval, 
            boolean empty, String name)
    {
        try {
            Report report = loadReport("dst.urp");
            DataSource ds = createGroupedCyclingSource(interval, grouper, empty);
            Map params = createIntervalParams(interval);
            params.put("title", new Value(I18n.getMsg(name)));
            showReportPreviewWindow(report, ds, params);
        } catch (Exception e) {
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
    }
    
    private void reportsYearlyRidesMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsYearlyRidesMenuItemActionPerformed
        DateInterval di = YearIntervalWindow.execute(this);
        if (di != null) 
            cyclingDstReport(new AnnualGrouper(), di, true, "reports.annualRides");
    }//GEN-LAST:event_reportsYearlyRidesMenuItemActionPerformed

    private void reportsMonthlyRidesMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsMonthlyRidesMenuItemActionPerformed
        DateInterval di = MonthIntervalWindow.execute(this);
        if (di != null)
            cyclingDstReport(new MonthlyGrouper(), di, true, "reports.monthlyRides");
    }//GEN-LAST:event_reportsMonthlyRidesMenuItemActionPerformed

    private void fileOpenReportMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fileOpenReportMenuItemActionPerformed
        JFileChooser fc = new JFileChooser();
        int ret = fc.showOpenDialog(this);
        if (ret == JFileChooser.APPROVE_OPTION) {
            com.fn.repway.ViewerWindow frame = new com.fn.repway.ViewerWindow(fc.getSelectedFile());
            frame.setVisible(true);
        }
    }//GEN-LAST:event_fileOpenReportMenuItemActionPerformed

    private void reportsWeeklyRidesMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsWeeklyRidesMenuItemActionPerformed
        DateInterval di = DateIntervalWindow.execute(this, 
                Utils.subMonth(new Date()), new Date());
        if (di != null)
            cyclingDstReport(new WeeklyGrouper(), di, true, "reports.weeklyRides");
    }//GEN-LAST:event_reportsWeeklyRidesMenuItemActionPerformed

    private void reportsDailyRidesMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsDailyRidesMenuItemActionPerformed
        DateInterval di = DateIntervalWindow.execute(this, 
                Utils.subMonth(new Date()), new Date());
        if (di != null)
            cyclingDstReport(new DailyGrouper(), di, false, "reports.dailyRides");
    }//GEN-LAST:event_reportsDailyRidesMenuItemActionPerformed

    private void cleanLastFiles() {
        int pos = lastFilesMenuStart;
        while (fileMenu.getItemCount() != emptyFileMenuSize)
            fileMenu.remove(pos);
    }
    
    private void addLastFiles() {
        List logs = Config.getLastLogs();
        int pos = lastFilesMenuStart;
        int no = logs.size();
        for (Iterator i = logs.iterator(); i.hasNext(); ) {
            final String s = (String)i.next();
            JMenuItem menuItem = new JMenuItem(Integer.toString(no) + ". " + s);
            menuItem.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    if (isReloadingAllowed())
                        openLog(new java.io.File(s));
                }
            });
            fileMenu.add(menuItem, pos);
            no--;
        }
    }
    
    private void buildFileMenu() {
        cleanLastFiles();
        addLastFiles();
    }
    
    private void fileSaveAsMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fileSaveAsMenuItemActionPerformed
        try {
            File f = chooseLogFileName();
            if (null != f) {
                log.saveAs(f);
                updateTitle();
                Config.addToLastLogs(log.getFile().getFile());
            }
        } catch (Exception e) {
            e.printStackTrace();
            JOptionPane.showMessageDialog(this, I18n.getMsg("mainForm.messages.saveError"));
        }
    }//GEN-LAST:event_fileSaveAsMenuItemActionPerformed

    private void showReportPreviewWindow(Report report, DataSet ds, Map params) throws Exception {
        DataSource dataSource = new DataSource(ds);
        showReportPreviewWindow(report, dataSource, params);
    }
    
    private void showReportPreviewWindow(Report report, DataSource ds, Map params) throws Exception {
        GeneratedReport gr = report.generate(ds, params);
        com.fn.repway.ViewerWindow frame = new com.fn.repway.ViewerWindow(gr);
        frame.setVisible(true);
    }
    
    private void reportsRidesMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportsRidesMenuItemActionPerformed
        DateInterval di = DateIntervalWindow.execute(this, 
                Utils.subMonth(new Date()), new Date());
        if (di != null) {
            try {
                Report report = loadReport("cycling/rides.urp");
                DataSet ds = new RidesDataSet(log.getEventsList(), di.getFromDate(), di.getToDate());
                Map params = createIntervalParams(di);
                showReportPreviewWindow(report, ds, params);
            } catch (Exception e) {
                System.out.println(e.getMessage());
                e.printStackTrace();
            }
        }
    }//GEN-LAST:event_reportsRidesMenuItemActionPerformed

    private void helpAboutMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_helpAboutMenuItemActionPerformed
        AboutWindow.execute(this);
    }//GEN-LAST:event_helpAboutMenuItemActionPerformed

    private void fileOptionsMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fileOptionsMenuItemActionPerformed
        com.fn.BikersLog.prefs.PreferencesDialog.execute(this);
        log.getEventsList().updateAll();
    }//GEN-LAST:event_fileOptionsMenuItemActionPerformed

    private void updateTitle() {
        String logName;
        java.io.File file = log.getFile().getFile();
        if (file == null)
            logName = I18n.getMsg("mainForm.untiteled");
        else
            logName = file.getPath();
        setTitle(I18n.getMsg("mainForm.title") + " - " + logName);
    }
    
    private void onNewLog() {
        view.setLog(log);
        buildFileMenu();
        updateTitle();
    }
    
    private boolean saveLog() {
        try {
            if (log.getFile().getFile() != null)
                log.save();
            else {
                File f = chooseLogFileName();
                if (null != f) {
                    log.saveAs(f);
                    updateTitle();
                } else
                    return false;
            }
        } catch (Exception e) {
            e.printStackTrace();
            JOptionPane.showMessageDialog(this, I18n.getMsg("mainForm.messages.saveError"));
            return false;
        }
        Config.addToLastLogs(log.getFile().getFile());
        return true;
    }
    
    private void saveLogBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveLogBtnActionPerformed
        saveLog();
    }//GEN-LAST:event_saveLogBtnActionPerformed

    private void openLog(java.io.File file) {
        try {
            log = new Log(file);
            if ((log.getFile().getMajorVersion() != DataFile.CURRENT_MAJOR_VERSION) ||
                    (log.getFile().getMinorVersion() != DataFile.CURRENT_MINOR_VERSION))
            {
                JOptionPane.showMessageDialog(this, I18n.getMsg("mainForm.messages.oldFile"));
                log.getFile().setUnnamed();
            } else
                Config.addToLastLogs(file);
            onNewLog();
        } catch (Exception e) {
            e.printStackTrace();
            JOptionPane.showMessageDialog(this, I18n.getMsg("mainForm.messages.loadError"));
        }
    }
    
    private void setupFilters(JFileChooser chooser) {
        chooser.addChoosableFileFilter(new SuffixFileFilter(".spt", "fileFilter.spt"));
    }
    
    private void openLogBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openLogBtnActionPerformed
        if (isReloadingAllowed()) {
            JFileChooser fc = new JFileChooser();
            setupFilters(fc);
            int ret = fc.showOpenDialog(this);
            if (ret == JFileChooser.APPROVE_OPTION) {
                openLog(fc.getSelectedFile());
            }
        }
    }//GEN-LAST:event_openLogBtnActionPerformed

    private File chooseLogFileName() {
        JFileChooser fc = new JFileChooser();
        setupFilters(fc);
        int ret = fc.showSaveDialog(this);
        if (ret == JFileChooser.APPROVE_OPTION) {
            File f = fc.getSelectedFile();
            if ((! f.isFile()) && (f.getName().indexOf('.') < 0))
                f = new File(f.getAbsolutePath() + ".spt");
            if (f.isFile()) {
                int res = JOptionPane.showConfirmDialog(this, 
                        I18n.getMsg("mainForm.messages.overwrite"), 
                        I18n.getMsg("mainForm.title"), JOptionPane.YES_NO_OPTION);
                if (res != JOptionPane.YES_OPTION)
                    return null;
            }
            return f;
        } else
            return null;
    }
    
    private boolean isReloadingAllowed() {
        if (log.isSaved())
            return true;
        
        int res = JOptionPane.showConfirmDialog(this, I18n.getMsg("mainForm.messages.notSaved"));
        if ((res == JOptionPane.CLOSED_OPTION) || (res == JOptionPane.CANCEL_OPTION))
            return false;
        if (res == JOptionPane.NO_OPTION)
            return true;

        return saveLog();        
    }
    
    private void newLogBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newLogBtnActionPerformed
        if (isReloadingAllowed()) {
            log = new Log();
            onNewLog();
        }
    }//GEN-LAST:event_newLogBtnActionPerformed
    
    private void fileExitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fileExitMenuItemActionPerformed
        exitForm(null);
    }//GEN-LAST:event_fileExitMenuItemActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        try {
            Config.setPosition(getBounds());
            view.saveOptions();
            Config.save();
        } catch (Exception e) { }
        if (isReloadingAllowed())
            System.exit(0);
    }//GEN-LAST:event_exitForm
    
    public static MainWindow getInstance() {
        return mainWindow;
    }
    
    public Log getLog() {
        return log;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem actCyclotrainerMenuItem;
    private javax.swing.JMenuItem actDeleteMenuItem;
    private javax.swing.JMenuItem actEditMenuItem;
    private javax.swing.JMenuItem actNoteMenuItem;
    private javax.swing.JMenuItem actRideMenuItem;
    private javax.swing.JMenuItem actRowMenuItem;
    private javax.swing.JMenuItem actRunningMenuItem;
    private javax.swing.JMenuItem actSkiingMenuItem;
    private javax.swing.JMenuItem actSwimmingMenuItem;
    private javax.swing.JMenu activitiesMenu;
    private javax.swing.JButton addCyclotrainerBtn;
    private javax.swing.JButton addNoteBtn;
    private javax.swing.JButton addRideBtn;
    private javax.swing.JButton addRowingBtn;
    private javax.swing.JButton addRunningBtn;
    private javax.swing.JButton addSkiingBtn;
    private javax.swing.JButton addSwimmingBtn;
    private javax.swing.JButton deleteEventBtn;
    private javax.swing.JButton editEventBtn;
    private javax.swing.JSeparator endFilesSeparator;
    private javax.swing.JMenuItem eqipBikesMenuItem;
    private javax.swing.JMenuItem eqipBoatsMenuItem;
    private javax.swing.JMenuItem eqipSkisMenuItem;
    private javax.swing.JMenu equipmentMenu;
    private javax.swing.JMenuItem fileExitMenuItem;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JMenuItem fileNewMenuItem;
    private javax.swing.JMenuItem fileOpenMenuItem;
    private javax.swing.JMenuItem fileOpenReportMenuItem;
    private javax.swing.JMenuItem fileOptionsMenuItem;
    private javax.swing.JMenuItem fileSaveAsMenuItem;
    private javax.swing.JMenuItem fileSaveMenuItem;
    private javax.swing.JMenuItem helpAboutMenuItem;
    private javax.swing.JMenu helpMenu;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JButton newLogBtn;
    private javax.swing.JButton openLogBtn;
    private javax.swing.JButton optionBtn;
    private javax.swing.JMenu repCyclingMenu;
    private javax.swing.JMenu repRowingMenu;
    private javax.swing.JMenu repRunningMenu;
    private javax.swing.JMenu repSkiingMenu;
    private javax.swing.JMenu repSwimmingMenu;
    private javax.swing.JMenuItem reportsDailyRidesMenuItem;
    private javax.swing.JMenuItem reportsDailyRowingMenuItem;
    private javax.swing.JMenuItem reportsDailyRunningMenuItem;
    private javax.swing.JMenuItem reportsDailySkiingMenuItem;
    private javax.swing.JMenuItem reportsDailySwimmingMenuItem;
    private javax.swing.JMenu reportsMenu;
    private javax.swing.JMenuItem reportsMonthlyRidesMenuItem;
    private javax.swing.JMenuItem reportsMonthlyRowingMenuItem;
    private javax.swing.JMenuItem reportsMonthlyRunningMenuItem;
    private javax.swing.JMenuItem reportsMonthlySkiingMenuItem;
    private javax.swing.JMenuItem reportsMonthlySwimmingMenuItem;
    private javax.swing.JMenuItem reportsRidesMenuItem;
    private javax.swing.JMenuItem reportsRowingMenuItem;
    private javax.swing.JMenuItem reportsRunningMenuItem;
    private javax.swing.JMenuItem reportsSkiingMenuItem;
    private javax.swing.JMenuItem reportsSwimmingMenuItem;
    private javax.swing.JMenuItem reportsWeeklyRidesMenuItem;
    private javax.swing.JMenuItem reportsWeeklyRowingMenuItem;
    private javax.swing.JMenuItem reportsWeeklyRunningMenuItem;
    private javax.swing.JMenuItem reportsWeeklySkiingMenuItem;
    private javax.swing.JMenuItem reportsWeeklySwimmingMenuItem;
    private javax.swing.JMenuItem reportsYearlyRidesMenuItem;
    private javax.swing.JMenuItem reportsYearlyRowingMenuItem;
    private javax.swing.JMenuItem reportsYearlyRunningMenuItem;
    private javax.swing.JMenuItem reportsYearlySkiingMenuItem;
    private javax.swing.JMenuItem reportsYearlySwimmingMenuItem;
    private javax.swing.JMenuItem routesBikesMenuItem;
    private javax.swing.JMenuItem routesBoatsMenuItem;
    private javax.swing.JMenu routesMenu;
    private javax.swing.JMenuItem routesRunMenuItem;
    private javax.swing.JMenuItem routesSkiingMenuItem;
    private javax.swing.JButton saveLogBtn;
    private javax.swing.JSeparator startFilesSeparator;
    private javax.swing.ButtonGroup viewButtonGroup;
    private javax.swing.JMenu viewMenu;
    private javax.swing.JRadioButtonMenuItem viewMonthMenuItem;
    private javax.swing.JRadioButtonMenuItem viewTableMenuItem;
    // End of variables declaration//GEN-END:variables
    
}
