/*
 * Metrics.java
 *
 * Created on 11  2004 ., 9:59
 */

package com.fn.BikersLog;


import java.util.ResourceBundle;


/**
 *
 * @author  asso
 */
public class Metrics {
    
    private Unit shortDistance;
    private Unit bigDistance;
    private Unit speed;
    private Unit height;
    private Unit weight;
    private String name;
    private String ident;
    
    /** Creates a new instance of Metrics */
    public Metrics(ResourceBundle bundle, String id) {
        String prefix = "type." + id + ".";
        shortDistance = new Unit(bundle, bundle.getString(prefix + "smallDistance"));
        bigDistance = new Unit(bundle, bundle.getString(prefix + "bigDistance"));
        speed = new Unit(bundle, bundle.getString(prefix + "speed"));
        height = new Unit(bundle, bundle.getString(prefix + "height"));
        weight = new Unit(bundle, bundle.getString(prefix + "weight"));
        ident = bundle.getString(prefix + "name");
        name = I18n.getMsg("metrics." + ident);
    }
    
    public Unit getShortDistance() {
        return shortDistance;
    }
    
    public Unit getBigDistance() {
        return bigDistance;
    }
    
    public Unit getSpeed() {
        return speed;
    }
    
    public Unit getHeight() {
        return height;
    }
    
    public Unit getWeight() {
        return weight;
    }
    
    public String getName() {
        return name;
    }
    
    public String getIdent() {
        return ident;
    }
    
    public String toString() {
        return getName();
    }
}
