/*
 * YearIntervalWindow.java
 *
 * Created on 1  2003 ., 15:08
 */

package com.fn.BikersLog;


import java.text.DateFormatSymbols;
import java.util.Date;
import java.util.Calendar;


/**
 *
 * @author  asso
 */
public class MonthIntervalWindow extends javax.swing.JDialog {
    
    boolean okPressed = false;
    private int fromMonth, fromYear;
    private int toMonth, toYear;
    private DateFormatSymbols dateFormatSymbols;
    
    /** Creates new form YearIntervalWindow */
    public MonthIntervalWindow(java.awt.Frame parent, int fromM, int fromY, int toM, int toY) {
        super(parent, true);
        dateFormatSymbols = new DateFormatSymbols();
        fromMonth = fromM;
        fromYear = fromY;
        toMonth = toM;
        toYear = toY;
        initComponents();
        okPressed = false;
        Utils.centerWindow(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        fromMonthCombo = new javax.swing.JComboBox();
        fromYearTextField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        toMonthCombo = new javax.swing.JComboBox();
        toYearTextField = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(I18n.getMsg("mainForm.title"));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 8, 8));

        okButton.setText(I18n.getMsg("generic.ok"));
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        jPanel1.add(okButton);

        cancelButton.setText(I18n.getMsg("generic.cancel"));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jPanel1.add(cancelButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jPanel2.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 0, 8)), new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(I18n.getMsg("dateIntervalForm.title")), new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)))));
        jLabel1.setText(I18n.getMsg("generic.from"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 4);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel1, gridBagConstraints);

        fromMonthCombo.setMaximumRowCount(12);
        fromMonthCombo.setModel(new MonthComboModel());
        fromMonthCombo.setMinimumSize(new java.awt.Dimension(100, 24));
        fromMonthCombo.setPreferredSize(new java.awt.Dimension(132, 24));
        fromMonthCombo.setSelectedIndex(fromMonth);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 4, 4, 4);
        jPanel2.add(fromMonthCombo, gridBagConstraints);

        fromYearTextField.setMinimumSize(new java.awt.Dimension(50, 19));
        fromYearTextField.setPreferredSize(new java.awt.Dimension(80, 19));
        fromYearTextField.setText(Integer.toString(fromYear));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 4, 4, 0);
        jPanel2.add(fromYearTextField, gridBagConstraints);

        jLabel2.setText(I18n.getMsg("generic.to"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 0, 4);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel2, gridBagConstraints);

        toMonthCombo.setMaximumRowCount(12);
        toMonthCombo.setModel(new MonthComboModel());
        toMonthCombo.setSelectedIndex(toMonth);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 4);
        jPanel2.add(toMonthCombo, gridBagConstraints);

        toYearTextField.setText(Integer.toString(toYear));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 0);
        jPanel2.add(toYearTextField, gridBagConstraints);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void fillMonthCombo(javax.swing.JComboBox comboBox) {
    }
    
    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        try {
            fromYear = Integer.parseInt(fromYearTextField.getText());
            toYear = Integer.parseInt(toYearTextField.getText());
            fromMonth = fromMonthCombo.getSelectedIndex();
            toMonth = toMonthCombo.getSelectedIndex();
        } catch (Exception e) {
            javax.swing.JOptionPane.showMessageDialog(this, I18n.getMsg("yearIntervalWindow.invalidDate"));
            return;
        }
        setVisible(false);
        okPressed = true;
    }//GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        setVisible(false);
    }//GEN-LAST:event_cancelButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
    }//GEN-LAST:event_closeDialog
    
    public static DateInterval execute(java.awt.Frame parent) {
        Calendar cal = Calendar.getInstance();
        int year = cal.get(Calendar.YEAR);
        int month = cal.get(Calendar.MONTH);
        cal.add(Calendar.YEAR, -1);
        cal.add(Calendar.MONTH, 1);
        return execute(parent, cal.get(Calendar.MONTH), cal.get(Calendar.YEAR), month, year);
    }
    
    public static DateInterval execute(java.awt.Frame parent, int fromM, int fromY, int toM, int toY) {
        MonthIntervalWindow mw = new MonthIntervalWindow(parent, fromM, fromY, toM, toY);
        mw.setVisible(true);
        mw.dispose();
        if (mw.okPressed) {
            Calendar calendar = Calendar.getInstance();
            calendar.clear();
            calendar.set(Calendar.YEAR, mw.fromYear);
            calendar.set(Calendar.MONTH, mw.fromMonth);
            Date fromDate = calendar.getTime();
            calendar.set(Calendar.YEAR, mw.toYear);
            calendar.set(Calendar.MONTH, mw.toMonth);
            calendar.add(Calendar.MONTH, 1);
            calendar.add(Calendar.MILLISECOND, -1);
            Date toDate = calendar.getTime();
            return new DateInterval(fromDate, toDate);
        } else
            return null;
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JComboBox fromMonthCombo;
    private javax.swing.JTextField fromYearTextField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JButton okButton;
    private javax.swing.JComboBox toMonthCombo;
    private javax.swing.JTextField toYearTextField;
    // End of variables declaration//GEN-END:variables
    
}
