/*
 * Picture.java
 *
 * Created on 24  2004 ., 10:44
 */

package com.fn.BikersLog;


import java.awt.geom.AffineTransform;
import java.awt.Graphics2D;
import java.awt.image.AffineTransformOp;
import java.awt.image.BufferedImage;
import javax.swing.JComponent;
//import javax.swing.ImageIcon;


/**
 *
 * @author  asso
 */
public class Picture extends JComponent {
    
    private BufferedImage image;
    private boolean fit;
    
    /** Creates a new instance of Picture */
    public Picture() {
        image = null;
        fit = true;
    }
    
    protected void paintComponent(java.awt.Graphics g) {
        Graphics2D g2 = (Graphics2D)g;
        g2.setPaint(getBackground());
        if ((null == image) || (image.getWidth() < 1) || 
                (image.getHeight() < 1))
            g2.fillRect(0, 0, getWidth(), getHeight());
        else {
            double zoom = 1.0;
            int w = getWidth();
            int h = getHeight();
            int iw = image.getWidth();
            int ih = image.getHeight();
            if (fit) {
                double vZoom = 1.0;
                double hZoom = 1.0;
                boolean needToZoom = false;
                if (iw > w) {
                    hZoom = (double)w / (double)iw;
                    needToZoom = true;
                }
                if (ih > h) {
                    vZoom = (double)h / (double)ih;
                    needToZoom = true;
                }
                if (needToZoom) {
                    zoom = vZoom < hZoom ? vZoom : hZoom;
                    iw = (int)(iw * zoom);
                    ih = (int)(ih * zoom);
                }
            }
            int x = (w - iw) / 2;
            int y = (h - ih) / 2;
            if ((0 != x) || (0 != y) || (w != iw) || (h != ih)) {
                g2.fillRect(0, 0, x, h);
                g2.fillRect(x + iw, 0, w - (x + iw), h);
                g2.fillRect(x, 0, w - (x + iw), y);
                g2.fillRect(x, h - (y + ih), w - (x + iw), h);
            }
            AffineTransform af = new AffineTransform();
            //af.translate(x, y);
            af.scale(zoom, zoom);
            AffineTransformOp op = new AffineTransformOp(af, AffineTransformOp.TYPE_BILINEAR);
            g2.drawImage(image, op, x, y);
        }
    }
    
    public BufferedImage getImage() {
        return image;
    }
    
    public void setImage(BufferedImage image) {
        this.image = image;
        repaint();
    }
    
}
