/*
 * Boat.java
 *
 * Created on 16  2004 ., 11:20
 */

package com.fn.BikersLog;


import org.w3c.dom.Text;
import org.w3c.dom.Document;
import org.w3c.dom.Element;


/**
 *
 * @author  asso
 */
public class Ski {
    
    private int id;
    private String name;
    private String description;
    private int type;
    private int refCnt;
    private boolean deleted;
    private int imageId;
    private ImageStorage imageStorage;

    /** Creates a new instance of Boat */
    public Ski(ImageStorage is) {
        id = 0;
        refCnt = 0;
        type = 1;
        deleted = false;
        imageId = 0;
        imageStorage = is;
    }
    
    public Ski(ImageStorage is, Element boat) {
        imageStorage = is;
        refCnt = 0;
        name = DOMUtil.getSubtagData(boat, "name", "");
        description = DOMUtil.getSubtagData(boat, "description", "");
        type = DOMUtil.getSubtagData(boat, "type", 1);
        id = DOMUtil.getSubtagData(boat, "id", 1);
        deleted = DOMUtil.getSubtagData(boat, "deleted", false);
        imageId = DOMUtil.getSubtagData(boat, "image", 0);
    }
    
    public String getName() {
        return name;
    }
    
    public void setName(String name) {
        this.name = name;
    }
    
    public String getDescription() {
        return description;
    }
    
    public void setDescription(String description) {
        this.description = description;
    }

    public String toString() {
        return name;
    }
    
    public int getType() {
        return type;
    }
    
    public void setType(int type) {
        this.type = type;
    }
    
    public void save(Document document, Element root) {
        if (deleted && (refCnt < 1)) {
            if (0 != imageId)
                imageStorage.removeImage(imageId);
            return;
        }
        Element boat = DOMUtil.addElement(document, root, "ski");
        DOMUtil.addDataElement(document, boat, "id", id);
        DOMUtil.addDataElement(document, boat, "name", name);
        DOMUtil.addDataElement(document, boat, "description", description);
        DOMUtil.addDataElement(document, boat, "type", type);
        DOMUtil.addDataElement(document, boat, "deleted", deleted);
        if (0 < imageId)
            DOMUtil.addDataElement(document, boat, "image", imageId);
    }
    
    public boolean isDeleted() {
        return deleted;
    }
    
    public void setDeleted(boolean v) {
        deleted = v;
    }
    
    public void addRef() {
        refCnt++;
    }
    
    public void delRef() {
        refCnt--;
    }
    
    public int getId() {
        return id;
    }
    
    public void setId(int v) {
        id = v;
    }
    
    public int getImage() {
        return imageId;
    }
    
    public void setImage(int image) {
        if (0 != imageId)
            imageStorage.removeImage(imageId);
        this.imageId = image;
    }
    
    public ImageStorage getImageStorage() {
        return imageStorage;
    }
}
