/*
 * BoatsList.java
 *
 * Created on 16  2004 ., 11:19
 */

package com.fn.BikersLog;


import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import javax.swing.AbstractListModel;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;


/**
 *
 * @author  asso
 */
public class SkisList extends AbstractListModel {
    
    private List skis;
    private Map allSkis;
    private ImageStorage imageStorage;
    
    /** Creates a new instance of BoatsList */
    public SkisList(ImageStorage is) {
        skis = new ArrayList();
        allSkis = new TreeMap();
        imageStorage = is;
    }
    
    public Ski get(int index) {
        return (Ski)skis.get(index);
    }
    
    public Ski getById(int id) {
        return (Ski)allSkis.get(new Integer(id));
    }
    
    public Object getElementAt(int index) {
        return get(index);
    }
    
    public int getSize() {
        return skis.size();
    }
    
    protected void load(Element root) {
        if (root == null) return;
        NodeList elements = root.getElementsByTagName("ski");
        int size = elements.getLength();
        for (int i = 0; i < size; i++) {
            Ski s = new Ski(imageStorage, (Element)elements.item(i));
            if (! s.isDeleted())
                skis.add(s);
            allSkis.put(new Integer(s.getId()), s);
        }
    }
    
    protected void save(Document document, Element root) {
        Element skis = DOMUtil.addElement(document, root, "skis");
        
        for (Iterator i = this.skis.iterator(); i.hasNext(); )
            ((Ski)i.next()).save(document, skis);
        
        for (Iterator i = allSkis.values().iterator(); i.hasNext(); ) {
            Ski s = (Ski)i.next();
            if (s.isDeleted())
                s.save(document, skis);
        }
    }
    
    public void add(Ski ski) {
        ski.setId(getNextId());
        allSkis.put(new Integer(ski.getId()), ski);
        if (! ski.isDeleted()) {
            skis.add(ski);
            fireIntervalAdded(this, skis.size() - 1, skis.size() - 1);
        }
    }
    
    public void change(int index) {
        fireContentsChanged(this, index, index);
    }
    
    public void delete(int index) {
        Ski s = get(index);
        s.setDeleted(true);
        skis.remove(index);
        fireIntervalRemoved(this, index, index);
    }
    
    public int getNextId() {
        int maxId = 0;
        for (Iterator i = allSkis.values().iterator(); i.hasNext(); ) {
            Ski s = (Ski)i.next();
            int id = s.getId();
            if (id > maxId)
                maxId = id;
        }
        return maxId + 1;
    }
    
    public int getIndexOf(Ski ski) {
        return skis.indexOf(ski);
    }
}
