/*
 * BoatsListWindow.java
 *
 * Created on 16  2004 ., 11:33
 */

package com.fn.BikersLog;


import java.awt.Frame;


/**
 *
 * @author  asso
 */
public class SkisListWindow extends GeneralListWindow {
    
    private Log log;

    /** Creates a new instance of BoatsListWindow */
    public SkisListWindow(Frame owner, Log log) {
        super(owner, I18n.getMsg("skisListForm.title"));
        this.log = log;
        itemsList.setModel(log.getSkisList());
    }
    
    public static void execute(Frame owner, Log log) {
        SkisListWindow slw = new SkisListWindow(owner, log);
        slw.setVisible(true);
    }
    
    /** This method is called when delete confirmation window needs message */
    protected String getDelPrompt(javax.swing.ListModel model, int itemNo) {
        return I18n.getMsg("skisListForm.areYouSure");
    }
    
    /** This method is called when add button pressed */
    protected void onAdd(javax.swing.ListModel model) {
        Ski ski = SkiWindow.add(this, log.getImageStorage());
        if (ski != null) {
            log.getSkisList().add(ski);
            itemsList.setSelectedIndex(log.getSkisList().getSize() - 1);
            log.markAsUnsaved();
        }
    }
    
    /** This method is called when edit button pressed */
    protected void onEdit(javax.swing.ListModel model, int itemNo) {
        Ski ski = log.getSkisList().get(itemNo);
        if (SkiWindow.edit(this, ski)) {
            log.getSkisList().change(itemNo);
            log.markAsUnsaved();
        }
    }
    
    /** This method is called when delete button pressed */
    protected void onDelete(javax.swing.ListModel model, int itemNo) {
        log.getSkisList().delete(itemNo);
        log.markAsUnsaved();
    }
}
