/*
 * Units.java
 *
 * Created on 29  2003 ., 12:28
 */

package com.fn.BikersLog;


import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.ResourceBundle;


/**
 *
 * @author  asso
 */
public class Units {
    
    private static Metrics current;
    private static List availMetrics;
    
    static {
        try {
            availMetrics = new LinkedList();
            ResourceBundle bundle = ResourceBundle.getBundle("com.fn.BikersLog/units");
            for (int i = 0; true; i++) {
                String id = Integer.toString(i);
                String name;
                try {
                    name = bundle.getString("type." + id + ".name");
                } catch (Exception e) {
                    break;
                }
                if ((null == name) || (0 == name.length()))
                    break;
                availMetrics.add(new Metrics(bundle, id));
            }
            setMetrics(Config.getUnits());
        } catch (Exception e) {
            System.out.println("Very strange: " + e.getMessage());
            e.printStackTrace();
        }
    }
    
    public static double fromStdSpeed(double v) {
        return current.getSpeed().fromStd(v);
    }
    
    public static double toStdSpeed(double v) {
        return current.getSpeed().toStd(v);
    }
    
    public static double fromStdHeight(double v) {
        return current.getHeight().fromStd(v);
    }
    
    public static double toStdHeight(double v) {
        return current.getHeight().toStd(v);
    }
    
    public static double fromStdWeight(double v) {
        return current.getWeight().fromStd(v);
    }
    
    public static double toStdWeight(double v) {
        return current.getWeight().toStd(v);
    }

    public static double fromStdBDist(double v) {
        return current.getBigDistance().fromStd(v);
    }
    
    public static double toStdBDist(double v) {
        return current.getBigDistance().toStd(v);
    }

    public static double fromStdSDist(double v) {
        return current.getShortDistance().fromStd(v);
    }
    
    public static double toStdSDist(double v) {
        return current.getShortDistance().toStd(v);
    }
    
    public static Metrics[] getAvailMetrics() {
        Metrics[] arr = new Metrics[0];
        return (Metrics[])availMetrics.toArray(arr);
    }
    
    public static Metrics getMetrics() {
        return current;
    }
    
    public static void setMetrics(Metrics metrics) {
        current = metrics;
    }
    
    public static void setMetrics(String name) {
        for (Iterator i = availMetrics.iterator(); i.hasNext(); ) {
            Metrics m = (Metrics)i.next();
            if (m.getIdent().equals(name)) {
                current = m;
                return;
            }
        }
        System.out.println("Metrics '" + name + "' not found!");
    }

    public static Unit getBDist() {
        return current.getBigDistance();
    }

    public static Unit getSDist() {
        return current.getShortDistance();
    }

    public static Unit getSpeed() {
        return current.getSpeed();
    }

    public static Unit getHeight() {
        return current.getHeight();
    }

    public static Unit getWeight() {
        return current.getWeight();
    }
    
    public static void load() {
    }
}
