/*
 * YearIntervalWindow.java
 *
 * Created on 1  2003 ., 15:08
 */

package com.fn.BikersLog;


import java.util.Date;
import java.util.Calendar;


/**
 *
 * @author  asso
 */
public class YearIntervalWindow extends javax.swing.JDialog {
    
    boolean okPressed = false;
    private int fromYear;
    private int toYear;
    
    /** Creates new form YearIntervalWindow */
    public YearIntervalWindow(java.awt.Frame parent, int from, int to) {
        super(parent, true);
        fromYear = from;
        toYear = to;
        initComponents();
        okPressed = false;
        Utils.centerWindow(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        fromTextField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        toTextField = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(I18n.getMsg("mainForm.title"));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 8, 8));

        okButton.setText(I18n.getMsg("generic.ok"));
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        jPanel1.add(okButton);

        cancelButton.setText(I18n.getMsg("generic.cancel"));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jPanel1.add(cancelButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jPanel2.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 0, 8)), new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(I18n.getMsg("dateIntervalForm.title")), new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)))));
        jLabel1.setText(I18n.getMsg("generic.from"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 4);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel1, gridBagConstraints);

        fromTextField.setMinimumSize(new java.awt.Dimension(50, 19));
        fromTextField.setPreferredSize(new java.awt.Dimension(140, 19));
        fromTextField.setText(Integer.toString(fromYear));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 4, 4, 0);
        jPanel2.add(fromTextField, gridBagConstraints);

        jLabel2.setText(I18n.getMsg("generic.to"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 0, 4);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel2, gridBagConstraints);

        toTextField.setText(Integer.toString(toYear));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 0);
        jPanel2.add(toTextField, gridBagConstraints);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        try {
            fromYear = Integer.parseInt(fromTextField.getText());
            toYear = Integer.parseInt(toTextField.getText());
            if (fromYear > toYear) {
                int a = fromYear;
                fromYear = toYear;
                toYear = a;
            }
        } catch (Exception e) {
            javax.swing.JOptionPane.showMessageDialog(this, I18n.getMsg("yearIntervalWindow.invalidDate"));
            return;
        }
        setVisible(false);
        okPressed = true;
    }//GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        setVisible(false);
    }//GEN-LAST:event_cancelButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
    }//GEN-LAST:event_closeDialog
    
    public static DateInterval execute(java.awt.Frame parent) {
        Calendar cal = Calendar.getInstance();
        int year = cal.get(Calendar.YEAR);
        return execute(parent, year - 10, year);
    }
    
    public static DateInterval execute(java.awt.Frame parent, int from, int to) {
        YearIntervalWindow yw = new YearIntervalWindow(parent, from, to);
        yw.setVisible(true);
        yw.dispose();
        if (yw.okPressed) {
            Calendar calendar = Calendar.getInstance();
            calendar.clear();
            calendar.set(Calendar.YEAR, yw.fromYear);
            Date fromDate = calendar.getTime();
            calendar.set(Calendar.YEAR, yw.toYear + 1);
            calendar.add(Calendar.MILLISECOND, -1);
            Date toDate = calendar.getTime();
            return new DateInterval(fromDate, toDate);
        } else
            return null;
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JTextField fromTextField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JButton okButton;
    private javax.swing.JTextField toTextField;
    // End of variables declaration//GEN-END:variables
    
}
